{ **************************************************************
  Datei: EXT_ASM.PAS
  --------------------------------------------------------------
  Autor: Sven Letzel
  Datum: 11.04.1993
  Funktion: Demonstriert die Einbindung von externen Assembler-
            modulen in ein Pascal-Programm
  Borland Pascal 7.0 - Zielplattform: Real, Protected
  **************************************************************}


{$L HEX.OBJ}
{* Assemblermodul einbinden *}

FUNCTION Num2Hex(Num: WORD): STRING; EXTERNAL;

FUNCTION XReadKey: WORD;
{* Erweiterte Readkey-Funktion fr erweiterte Tastatur
   Rckgabe:
     normale Tasten: LOBYTE = ASCII-Zeichen der Taste
                     HIBYTE = Auswahlcode der Taste
     Sondertasten  : LOBYTE = 0
                     HIBYTE = Kennzeichen der Sondertaste
*}
INLINE(
      $B4/$10/       {* MOV AH, 10h *}
      $CD/$16);      {* INT 16h *}

VAR
  Zahl: WORD;
BEGIN
  WriteLn('DEMO-Program fr externen Assembler.');
  WriteLn('Test fr erweiterte Tastatur. (ESC=Ende)');
  REPEAT
    Zahl := XReadKey;
    WriteLn('ASCII: ',Lo(Zahl):3,' = $',Num2Hex(Lo(Zahl)));
    WriteLn('ACODE: ',Hi(Zahl):3,' = $',Num2Hex(Hi(Zahl)));
    WriteLn;
  UNTIL Lo(Zahl) = 27;
END.
