(* ------------------------------------------------------ *)
(*                       REDOUT.PAS                       *)
(*   Standardausgabe fr einen Tochterproze umleiten     *)
(*             (c) 1993 te-wi Verlag, Mnchen             *)
(* ------------------------------------------------------ *)
PROGRAM RedirectOutput;

CONST
  stdin   : WORD = 0;
  stdout  : WORD = 1;
  stderr  : WORD = 2;

  RedFile : STRING = 'STDOUT.RED' + #0;

VAR
  oldin  : WORD;
  oldout : WORD;
  olderr : WORD;
  Err    : WORD;

BEGIN
  ASM
    MOV  BX, stdout
    MOV  AH, 45h
    INT  21h                   (* duplicate stdout        *)
    JC   @Error                (* failed                  *)

    MOV  oldout, AX            (* save stdout             *)

    MOV  CX, 0                 (* normal attribute        *)
    MOV  DX, OFFSET redfile + 1
    MOV  AH, 3Ch
    INT  21h
    JC   @Error                (* failed                  *)

    MOV  BX, AX                (* redirect stdout hdle to *)
    MOV  CX, stdout            (* track the new file hdle *)
    MOV  AH, 46h
    INT  21h
    JC   @Error                (* failed                  *)

    JMP  @ok
  @Error:
    MOV  Err, AX               (* Error code              *)
  @Ok:
  END;
  WriteLn('Error #', Err);     (* Ok: Error to STDOUT.RED *)

  ASM
    MOV  BX, oldout            (* restore original handle *)
    MOV  CX, stdout
    MOV  AH, 46h
    INT  21h
    JC   @Error2               (* failed                  *)

    MOV  BX, oldout            (* close dup'd handle      *)
    MOV  AH, 3Eh
    INT  21h
    JC   @Error2               (* failed                  *)

    JMP  @ok2
  @Error2:
    MOV  Err, AX
  @Ok2:
  END;
  WriteLn('Error #', Err);     (* Ok: Error to CON        *)
END.
(* ------------------------------------------------------ *)
(*                  Ende von REDOUT.PAS                   *)
