(* ------------------------------------------------------ *)
(*                      TEST.PAS                          *)
(*             (c) 1993 te-wi Verlag, Mnchen             *)
(* ------------------------------------------------------ *)
PROGRAM Test;

{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

USES Objects, Drivers, Memory, Views, Menus, Editors, TestBed, App,
     MsgBox;

TYPE
  tTestApp = OBJECT (tBedApp)
    PROCEDURE   HandleEvent(VAR Event : tEvent); VIRTUAL;
  END;

  PROCEDURE tTestApp.HandleEvent(VAR Event : tEvent);
  BEGIN
    inherited HandleEvent(Event);

    IF Event.What = evCommand THEN BEGIN
      CASE Event.Command OF

        cmEins : MessageBox('Dies ist Fenster 1', NIL,
                            mfInformation + mfOkButton);

        cmZwei : DebugBox(cmZwei);
        cmDrei : DebugBox(cmDrei);
      ELSE
        Exit;
      END;
      ClearEvent(Event);
    END;
  END;

VAR
  TestApp : tTestApp;

BEGIN
  TestApp.Init;
  TestApp.Run;
  TestApp.Done;
END.
(* ------------------------------------------------------ *)
(*                  Ende von TEST.PAS                     *)

 
