PROGRAM Clippa;

USES WinTypes, WinProcs, Strings, WinCrt;

CONST
  ClipName1: ARRAY [0..11] OF STRING[20] =
    ('cf_Text', 'cf_Bitmap', 'cf_MetafilePict', 'cf_Sylk', 'cf_DIF', 'cf_TIFF',
     'cf_OEMText', 'cf_DIB', 'cf_Palette', 'cf_PenData', 'cf_RIFF', 'cf_Wave');
  ClipName2: ARRAY [$80..$83] OF STRING[20] =
    ('cf_OwnerDisplay', 'cf_DSPText', 'cf_DSPBitmap', 'cf_DSPMetafilePict');

VAR
  i, FormatName, Format, CBFormats: INTEGER;
  pName: ARRAY [0..63] OF CHAR;
  sName: STRING[64];
  Window: hWND;

BEGIN
  InitWinCrt;
  CBFormats := CountClipboardFormats;
  WriteLn;
  WriteLn ('gefundene Clipboardformate: ', CBFormats);
  WriteLn;
  Window := GetActiveWindow;
  IF (CBFormats > 0) THEN BEGIN
    OpenClipboard (Window);
    Format := 0;
    FOR i := 0 TO CBFormats-1 DO BEGIN
      Format := EnumClipboardFormats (Format);
      FormatName := GetClipboardFormatName (Format, pName, 63);
      IF (FormatName = 0) THEN BEGIN
        IF (Format <= 12)
          THEN WriteLn ('Clipboard Format = ',ClipName1[Format -  cf_Text])
          ELSE IF ((Format >= 128) AND (Format <= 131))
            THEN WriteLn ('Clipboard Format = ',ClipName2[Format])
            ELSE WriteLn ('Format nicht bekannt');
      END
      ELSE BEGIN
        WriteLn ('Clipboard Format = ', StrPas(pName));
      END;
    END;
    CloseClipboard;
  END;
  ReadLn;
  DoneWinCrt;
END.
