(*===================================================================*)
(*                             EXTDRV.PAS                            *)
(*             Bindet die erweiterten BGI-Treiber ein                *)
(*===================================================================*)
UNIT ExtDrv;

INTERFACE

USES
  Graph, GraphErg;

PROCEDURE SVGADriverProc;
PROCEDURE VEAS16DriverProc;
PROCEDURE VGA256DriverProc;

IMPLEMENTATION

VAR
  UserDriver : INTEGER;

PROCEDURE SVGADriverProc;    EXTERNAL; {$L SVGA.OBJ}
PROCEDURE VESA16DriverProc;  EXTERNAL; {$L VESA16.OBJ}
PROCEDURE VGA256DriverProc;  EXTERNAL; {$L VGA256.OBJ}

BEGIN
(*
 In jedem Programm darf nur ein Treiber registriert werden (eingebunden
 drfen mehr sein !!!!!
*)
{$IFDEF SVGA}
  UserDriver := RegisterBGIDriver(@SVGADriverProc);
{$ENDIF}
{$IFDEF VESA16}
  UserDriver := RegisterBGIDriver(@VESA16DriverProc);
{$ENDIF}
{$IFDEF VGA256}
  UserDriver := RegisterBGIDriver(@VGA256DriverProc);
{$ENDIF}

END.
(*===================================================================*)