#=====================================================================#
#                             GRAFOVR.MAK                             #
#            Projektdatei fr das Demoprogramm GRAFOVR.EXE            #
#                   Aufruf mit MAKE -fGRAFOVR                       #
#=====================================================================#


#---------------------------------------------------------------------#
#                       Hauptprogramm compilieren:                    #
#---------------------------------------------------------------------#

GRAFOVR.EXE: GRAFOVR.PAS BGIOVR.TPU BGIDRV.TPU
  TPC GRAFOVR

#---------------------------------------------------------------------#
#                       TPU-Dateien compilieren:                      #
#---------------------------------------------------------------------#

BGIOVR.TPU: BGIOVR.PAS BGIDRV.TPU BOLD_.TPU EURO_.TPU GOTH_.TPU \
TSCR_.TPU LCOM_.TPU LITT_.TPU SANS_.TPU SCRI_.TPU SIMP_.TPU TRIP_.TPU
  TPC BGIOVR

BOLD_.TPU: BOLD_.PAS BOLD.OBJ
  TPC BOLD_

EURO_.TPU: EURO_.PAS EURO.OBJ
  TPC EURO_

GOTH_.TPU: GOTH_.PAS GOTH.OBJ
  TPC GOTH_

TSCR_.TPU: TSCR_.PAS TSCR.OBJ
  TPC TSCR_

LCOM_.TPU: LCOM_.PAS LCOM.OBJ
  TPC LCOM_

LITT_.TPU: LITT_.PAS LITT.OBJ
  TPC LITT_

SANS_.TPU: SANS_.PAS SANS.OBJ
  TPC SANS_

SCRI_.TPU: SCRI_.PAS SCRI.OBJ
  TPC SCRI_

SIMP_.TPU: SIMP_.PAS SIMP.OBJ
  TPC SIMP_

TRIP_.TPU: TRIP_.PAS TRIP.OBJ
  TPC TRIP_

#---------------------------------------------------------------------#

BGIDRV.TPU: BGIDRV.PAS CGA.OBJ EGAVGA.OBJ IBM8514.OBJ PC3270.OBJ \
ATT.OBJ HERC.OBJ
  TPC /B BGIDRV

#---------------------------------------------------------------------#
#                         OBJ-Dateien erstellen                       #
#---------------------------------------------------------------------#

BOLD.OBJ: BOLD.CHR
  BINOBJ BOLD.CHR BOLD BoldFontProc

EURO.OBJ: EURO.CHR
  BINOBJ EURO.CHR EURO EuropeanFontProc

GOTH.OBJ: GOTH.CHR
  BINOBJ GOTH.CHR GOTH GothicFontProc

LCOM.OBJ: LCOM.CHR
  BINOBJ LCOM.CHR LCOM ComplexFontProc

LITT.OBJ: LITT.CHR
  BINOBJ LITT.CHR LITT SmallFontProc

SANS.OBJ: SANS.CHR
  BINOBJ SANS.CHR SANS SansSerifFontProc

SCRI.OBJ: SCRI.CHR
  BINOBJ SCRI.CHR SCRI ScriptFontProc

SIMP.OBJ: SIMP.CHR
  BINOBJ SIMP.CHR SIMP SimplexFontProc

TRIP.OBJ: TRIP.CHR
  BINOBJ TRIP.CHR TRIP TriplexFontProc

TSCR.OBJ: TSCR.CHR
  BINOBJ TSCR.CHR TSCR TriplexScriptFontProc

CGA.OBJ: CGA.BGI
  BINOBJ CGA.BGI CGA CGADriverProc

EGAVGA.OBJ: EGAVGA.BGI
  BINOBJ EGAVGA.BGI EGAVGA EGAVGADriverProc

HERC.OBJ: HERC.BGI
  BINOBJ HERC.BGI HERC HercDriverProc

ATT.OBJ: ATT.BGI
  BINOBJ ATT.BGI ATT Att400DriverProc

PC3270.OBJ: PC3270.BGI
  BINOBJ PC3270.BGI PC3270 PC3270DriverProc

IBM8514.OBJ: IBM8514.BGI
  BINOBJ IBM8514.BGI IBM8514 IBM8514DriverProc

#=====================================================================#
