(* ------------------------------------------------------ *)
(*                      RES4.PAS                          *)
(*       Demonstration der Verwendung von Ressourcen      *)
(*             (c) 1993 te-wi Verlag, Mnchen             *)
(* ------------------------------------------------------ *)
PROGRAM Res4;

{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

USES Objects, Drivers, Views, Menus, App;

TYPE
  tAnApp = OBJECT (tApplication)
    CONSTRUCTOR Init;
    PROCEDURE   InitMenuBar;    VIRTUAL;
    PROCEDURE   InitStatusLine; VIRTUAL;
    DESTRUCTOR  Done;           VIRTUAL;
  END;

VAR
  ResFile : tResourceFile;

  CONSTRUCTOR tAnApp.Init;
  BEGIN
    RegisterMenus;
    RegisterObjects;
    RegisterViews;
    RegisterApp;
    ResFile.Init(New(pBufStream, Init('RES1.RES', stOpenRead, 1024)));

    inherited Init;
  END;

  PROCEDURE tAnApp.InitMenuBar;
  BEGIN
    MenuBar := pMenuBar(ResFile.Get('APPMENU'));
  END;

  PROCEDURE tAnApp.InitStatusLine;
  BEGIN
    StatusLine := pStatusLine(ResFile.Get('STATLINE'));
  END;

  DESTRUCTOR tAnApp.Done;
  BEGIN
    ResFile.Done;
    inherited Done;
  END;

VAR
  AnApp : tAnApp;

BEGIN
  AnApp.Init;
  AnApp.Run;
  AnApp.Done;
END.
(* ------------------------------------------------------ *)
(*                  Ende von RES4.PAS                     *)

 
