(* ------------------------------------------------------ *)
(*                      TXDOS.PAS                         *)
(*             (c) 1993 te-wi Verlag, Mnchen             *)
(* ------------------------------------------------------ *)
UNIT TxDos;

{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

INTERFACE

USES Dos;

  FUNCTION Exists(FileName : PathStr) : BOOLEAN;
  PROCEDURE Kill(FileName : PathStr);
  FUNCTION SetDefaultExt(FileName : PathStr; DefExt : ExtStr) : PathStr;

IMPLEMENTATION

  FUNCTION Exists(FileName : PathStr) : BOOLEAN;
  VAR
    SR : SearchRec;
  BEGIN
    FindFirst(FileName, AnyFile, SR);
    Exists := DosError = 0;
  END;

  PROCEDURE Kill(FileName : PathStr);
  VAR
    f : File;
  BEGIN
    Assign(f, FileName);
    IF Exists(FileName) THEN Erase(f);
  END;

  FUNCTION SetDefaultExt(FileName : PathStr; DefExt : ExtStr) : PathStr;
  VAR
    Dir  : DirStr;
    Name : NameStr;
    Ext  : ExtStr;
  BEGIN
    FSplit(FileName, Dir, Name, Ext);
    SetDefaultExt := Dir + Name + DefExt;
  END;

END.
(* ------------------------------------------------------ *)
(*                 Ende von TXDOS.PAS                     *)

